#include <stdio.h>
#include <stdlib.h>
#include "gfx.h"

static char *sample_ext[]=
{
  "Image Files",
  "  JPEG images (*.jpg *.jpeg)",
  "  PNG images (*.png)",
  "Audio Files",
  "  Microsoft WAVE format (*.wav)",
  "  MPEG Layer 3 (*.mp3)",
  NULL
};


int main(int argc,char **argv)
{
  char buf[2000];
  gfx_init(NULL,800,600,"Widget Demo");
  gfx_SCREEN_0();
  char *str;
  int selecting;

  gfx_canvas_setsize(TWcanvas, 400,400);
  gfx_canvas_fill_rectangle(TWcanvas, 0xFFffff, 0,0, 400, 400);
  gfx_canvas_draw_rectangle(TWcanvas, 0xFF0000, 20, 20, 300, 300);
  gfx_canvas_draw_rectangle(TWcanvas, 0x000000, 30, 40, 50, 50);

  selecting= 0;

  while(1)
  {
    gfx_event_t event;
    if (!gfx_event(NULL,&event)) continue;
    switch(event.type)
    {
      case GFXEV_QUIT: goto done;
      case TWbutton: 
        gfx_set_text(MESSAGE, "Button was clicked.");
        break;
      case TWtoggle: 
        sprintf(buf,"Toggle button: %d", event.key);
        gfx_set_text(MESSAGE,buf);
        break;
      case TWcheckbox:
        sprintf(buf,"Check box: %d", event.key);
        gfx_set_text(MESSAGE,buf);
        break;
      case TWradio1:
        gfx_set_text(MESSAGE,"Radio: first option");
        break;
      case TWradio2:
        gfx_set_text(MESSAGE,"Radio: second option");
        break;
      case TWradio3:
        gfx_set_text(MESSAGE,"Radio: third option");
        break;
      case TWconfirm:
        sprintf(buf,"Dialog result: %d",
          gfx_ask("Confirmation Dialog",
              "!OK!Cancel!Third Button!Fourth Button",
              "This is a message or confirmation dialog, intended\n"
              "for %s messages. It can display up to %d buttons.\n"
              "\nThe text you see here is specified using a format string\n"
              "and the associated arguments in the same way it's done for\n"
              "the printf function.", "short", 8));
        gfx_set_text(MESSAGE,buf);
        break;
      case TWfileselR:
        str= gfx_select_file(0,"/home/",  NULL);//sample_ext);
        sprintf(buf,"File selection result: '%s'", str? str: "(NULL)");
        gfx_set_text(MESSAGE,buf);
        break;
      case TWfileselW:
        str= gfx_select_file(1,"/home/", NULL);// sample_ext);
        sprintf(buf,"File selection result: '%s'", str? str: "(NULL)");
        gfx_set_text(MESSAGE,buf);
        break;
      case GFXEV(TWcanvas,BUTTON_PRESS):
        printf("canvas click: %d (%d,%d)\n",event.button,event.x,event.y);
        sprintf(buf,"Canvas button press %d: (%d,%d)", event.button, event.x,event.y);
        gfx_set_text(MESSAGE,buf);
        break;
      case GFXEV(TWcanvas,BUTTON_RELEASE):
        printf("canvas release: %d (%d,%d)\n",event.button,event.x,event.y);
        if (event.button==1)
        {
           if (selecting) 
           {
             int x1,y1,x2,y2;
             int x,y,w,h;
             gfx_canvas_recsel_end(TWcanvas, &x1, &y1, &x2, &y2);
             x= (x1<x2?x1:x2);
             y= (y1<y2?y1:y2);
             w= (x1+x2)-2*x+1;
             h= (y1+y2)-2*y+1;
             gfx_canvas_draw_rectangle(TWcanvas, 0, x,y,w,h);
             selecting= 0;
           }
           else
           {
             gfx_canvas_recsel_begin(TWcanvas, &event);
             selecting= 1;
           }
           break;
        }
        sprintf(buf,"Canvas button release %d: (%d,%d)", event.button, event.x,event.y);
        gfx_set_text(MESSAGE,buf);
        break;
    }
  }
done: 
  return 0;
}
