#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "path.h"


static void strmove(char *dst,char *src)
{
  memmove(dst, src, strlen(src)+1);
}

__PATH_PROTO char *path_file(char *path)
{
  char *G;
  int L;
  path= strdup(path);
  L= strlen(path);
  if (L==0) return path;
  while(L>0 && path[L-1]=='/') path[--L]= 0;
  if (L==0) return path;
  G= strrchr(path,'/');
  if (G)
    strmove(path, G+1);
  return path;
}

__PATH_PROTO char *path_dir(char *path)
{
  char *G;
  path= strdup(path);
  G= strrchr(path,'/');
  if (!G) { free(path); return strdup("."); }
  while(G>path && G[0]=='/') { G[0]= 0; G--; }
  return path;
}

__PATH_PROTO char* path_absolute(char *path)
{
  char *up,*p,*bad;
  int L;

  if (path[0]!='/')
  {
    char *cwd;
    char *R;
    char store[2000];
    cwd= getcwd(store, sizeof(store));
    if (!cwd) cwd= "/";
    R= malloc(strlen(cwd)+strlen(path)+2);
    R[0]= 0;
    strcat(R, cwd);
    strcat(R, "/");
    strcat(R, path);
    path= R;
  }
  else 
    path= strdup(path);

again:
  bad= strstr(path,"/./");
  if (bad) { strmove(bad, bad+2); goto again; }
  bad= strstr(path,"//");
  if (bad) { strmove(bad, bad+1); goto again; }
  up= strstr(path,"/../");
  if (up)
  {
    if (up==path)
      p= path;
    else
      for(p=up-1;p>path;p--) if (p[0]=='/') break;
    strmove(p, up+3);
    goto again;
  }

  L= strlen(path);
  if (L>1 && path[L-1]=='/') path[L-1]= 0;

  return path;
}

__PATH_PROTO char *path_relative(char *path, char *pivot)
{
  int i,j,k;
  int count;
  char *result;

  path= path_absolute(path);
  pivot= path_absolute(pivot);

  for(i=0;path[i];i++)
    if (path[i]!=pivot[i]) break;

  if (!path[i]) 
  {
    result= path_file(path);
    goto done;
  }

  count= 1;
  for(j=i-1;j>0;j--) if (path[j]=='/') break;

  /* from j to end, count how many directories you have.. */

  count= 0;
  for(k=j+1;path[k];k++) if (path[k]=='/') count++;

  result= malloc(strlen(path+j) + count*3 + 1);
  result[0]= 0;
  for(i=0;i<count;i++) strcat(result,"../");
  strcat(result,path+j+1);

done:
  free(path);
  free(pivot);
  return result;
}

__PATH_PROTO char *path_child(char *path,char *child)
{
  char *R;
  R= malloc(strlen(path) + strlen(child) + 2);
  strcpy(R,path);
  strcat(R, "/");
  strcat(R, child);
  return R;
}

