#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>
#include "ptrbuf.h"
#include "strbuf.h"
#include "expr.h"
#include "widget.h"
#include "pngio.h"
#include "gfx.h"
#include "show_resources.h"

static int  klik_index=-1; static resource_t *klik_resource;

static void vError(char *msg)
{
  gfx_set_text(WresMESSAGE, msg);
}

static void vclr()
{
  vError("");
}

static int load_color_image(char *fn, size_t *Rlen, uint8_t **Rdata)
{
  char *e;
  unsigned int w,h,*data;
  unsigned int *cdata;
  e= read_png_image(fn,&w,&h,&data);
  if (e) { vError(e); free(e); return 1; } 
  cdata= malloc(sizeof(unsigned int)*(2+w*h));
  cdata[0]= w | (1<<31);
  cdata[1]= h;
  memcpy(cdata+2, data, sizeof(unsigned int)*w*h);
  free(data);
  *Rdata= (void*) cdata;
  *Rlen= (w*h+2)*sizeof(unsigned int);
  return 0;
}


char* show_resources()
{
  char buf[200];
  static int lastvar;
  char *s1;
  static char *image_types[]= { "Portable Network Graphics (*.png)", NULL};
  size_t dlen;
  uint8_t *data;
  resource_t *R;
  gfx_event_t event;
  char *ret;
  char *fn;

  gfx_SCRres();

  klik_index= -1; klik_resource= NULL;

  for(R=resources;R;R=R->next)
    gfx_insert(WresLIST,-1,R->ident,R,NULL);

  ret= NULL;

  while(1)
  {
   if (!gfx_event(NULL,&event)) continue;
   switch(event.type)
   {
   case WresUSE: 
      if (klik_index==-1 || klik_resource==NULL) continue;
      ret= klik_resource->ident;
      goto done;
   case GFXEV_QUIT:
   case WresCLOSE:
      ret= NULL;
      goto done;
   case WresLIST:
      vclr();
      klik_index= event.key;
      klik_resource= event.usr;
      gfx_set_selected(WresLIST, klik_index);
      break;
   case WresADD:
      vclr();
      fn= gfx_select_file(0,NULL, image_types);
      if (!fn) break;
      if (load_color_image(fn,&dlen,&data)) continue;
      R= calloc(1,sizeof(*R));
      R->length= dlen;
      R->data= data;
      s1= gfx_get_text(WresNAME);
      if (!s1 || !s1[0])
      {
         sprintf(buf,"res%d", lastvar++);
         s1= buf;
      }
      R->ident= strdup(s1);
      R->type= TYP_COLORIMG;
      R->next= resources;
      resources= R;
      gfx_insert(WresLIST, 0, R->ident, R, NULL);
      break;
   }
  }
  
done:
  gfx_leave_screen();
  return ret;
}
