#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *f;
char *name;

char *tab[256]=
{
  ['\n']= "\\n\"\n\"",
  ['\t']= "\\t",
  ['\r']= "\\r",
};

static void start()
{
  printf("static const char *%s[]= {\n\"",name);
}

static void finish()
{
  printf("\" };\n");
}

static void switch_elements()
{
  printf("\",\n\"");
}

static int isinv(unsigned int B)
{
  return B<32 || B>126 || B=='\\' || B=='\'' || B=='\"';
}

static void output(char *S,int len)
{
  int i;
  unsigned char *B;
  B= (void*) S;
  char *hex= "0123456789abcdef";
  while(len)
  {
    for(i=0;i<len;i++)
      if (isinv(B[i])) break;
    if (i) fwrite(B,1,i, stdout);
    if (i<len) 
    {
      if (tab[B[i]]) printf("%s",tab[B[i]]);
      else printf("\\%03o", B[i]);
      B+=i+1;
      len-=i+1;
    }
    else
      break;
  }
}

char *key;
int keyL;
int getkey()
{
  static char g[2000];
  int i;
  if (!fgets(g,sizeof(g),stdin)) return 1;
  g[sizeof(g)-1]= 0;
  for(i=0;g[i];i++) if (g[i]=='\r'||g[i]=='\n') { g[i]= 0;break;}
  if (g[0]==0) return 1;
  key= g;
  keyL= strlen(g);
  return 0;
}

int main(int argc,char **argv)
{
  char buffer[4096];
  char *buffer_end;
  char *read_start, *data_end, *search_start;
  int length;
  int R;
  char *z;

  if (argc!=3) 
    exit(fprintf(stderr,"usage: %s input-file array-name\n", argv[0]));


  f= fopen(argv[1],"r");
  if (!f)
    exit(fprintf(stderr,"can't open %s\n",argv[1]));
  name= argv[2];

  start();


  read_start= buffer;
  length= 0;
  buffer_end= buffer+sizeof(buffer);

  if (getkey()) goto copy_all;

read_more:
  read_start= buffer+length;
  R= fread(read_start,1,buffer_end-read_start,f);
  if (R<=0) goto no_more_data;
  length+= R;
  search_start= buffer;
    
search_more:
  data_end= buffer+length;
  z= memchr(search_start, key[0], data_end-search_start);
  if (!z)
  {
    output(buffer, length);
    length= 0; 
    goto read_more;
  }
  if (z+keyL>data_end)
  {
    output(buffer,z-buffer);
    memmove(buffer, z, data_end-z);
    length= data_end-z;
    goto read_more;
  }
  if (memcmp(z,key,keyL)) { search_start= z+1; goto search_more; }
  // found:
  z+= keyL;
  output(buffer,z-buffer);
  switch_elements();

  if (getkey()) goto copy_rest;

  memmove(buffer, z, data_end-z);
  length= data_end-z;
  goto search_more;

copy_rest:

  output(z, data_end-z);

copy_all:

  while(1)
  {
    R= fread(buffer,1,buffer_end-buffer,f);
    if (R<=0) break; 
    output(buffer, R);
  }
no_more_data:

  finish();
  return 0;
}
